package org.modeshape.ejbtest;

import javax.annotation.Resource;
import javax.ejb.Asynchronous;
import javax.ejb.Stateless;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jcr.Node;
import javax.jcr.Session;
import javax.jcr.SimpleCredentials;
import javax.jcr.nodetype.NodeType;
import javax.naming.InitialContext;
import javax.transaction.UserTransaction;

import org.jboss.logging.Logger;

@Stateless
@TransactionManagement(TransactionManagementType.BEAN)
public class VerifyNodesTest  {
	
	private static Logger log = Logger.getLogger(VerifyNodesTest.class);
	
	private static int COUNT = 10;
	
//	@Resource(lookup="jcr/sample")
//	private Repository repository;
	
	@Resource
	private UserTransaction ut;
	
	@Asynchronous
	public void run() throws Exception {
		ut.begin();
		InitialContext context = new InitialContext();
		javax.jcr.Repository repository = (javax.jcr.Repository) context.lookup("jcr/sample");
		Session session = repository.login(new SimpleCredentials("admin", "admin".toCharArray()));
		Node root = session.getRootNode();

		for (int i = 1; i <= COUNT; i++) {
			Node node = root.getNode("node" + i);
			log.info("Verifying " + node.getPath());
			node.getProperty("prop").getString().equals("Property value for " + node.getIdentifier());
			for (int j = 1; j <= COUNT; j++) {
				Node child = node.getNode("child" + j);
				log.info("Verifying " + child.getPath());
				child.getProperty("prop").getString().equals("Property value for " + node.getIdentifier());
				for (int k = 1; k <= COUNT; k++) {
					Node grandChild = child.getNode("grandchild" + k);
					grandChild.getProperty("prop").getString().equals("Property value for " + node.getIdentifier());
				}
				ut.commit();
				ut.begin();
			}
		}
		ut.commit();
		log.info("VerifyNodesTest completed");
	}
	
}
